# Resmax: An Alternative Soft-Greedy Operator for Reinforcement Learning
This is the git repo for the resmax paper. This readme will guide you through running the experiments that have been presented in the paper.


# Getting Started
You should first [install python](https://www.python.org/downloads/). Note that we have only tested our code with python versions 3.6 and 3.7. We also recommend using a [virtual environment](https://docs.python.org/3/tutorial/venv.html).

# Prerequisites

First, you should install the libraries provided in `libs` directory. To do this, you should first place the working directory of your terminal in the project root directory. Then, run the following commands:
```bash
cd libs/gym-exploration/
pip install -e .
cd ../gym-recording-modified/
pip install -e .
cd ../gym-riverswim/
pip install -e .
cd ../Riverswim-Variants/
pip install -e .
```
Next you should run the following line in the root directory to install all third-party libraries:
```bash
pip install -r requirements.txt
```
All the required libraries are now installed!

# Reproducing Results
The instructions for running the experiments in the tabular, linear, and deep RL settings have been provided in the README files in their directories, which are located under `rl_exploration`.
